typedef unsigned int word;
typedef unsigned char byte;

#include <8051.h>
#include <string.h>
#include <stdio.h>

#include "mnghw.h"
#include "base.h"
#include "circle.h"
#include "token.h"
#include "queue.h"

bit online = 1;

void onlinefce(void) interrupt 0 using 1
{
	T0 = online;		// ledka
	online = !online;	// novy stav
//	EX0 = 0;		// zakaz preruseni
//	EX0 = 1;	// povol preruseni online tlacitkem
}

main()
{
	char command[3];
        int arg[2];
	TPenState OldPenState;

	// stisknuto tlacitko pri zapnuti
	// nastav vystupy na HI (umozni rizeni pres PC)
	if (!(P3 & 0x04))
		while (1);

	// casovac T0 pro casovani motoru a zrychlovani - 16bitovy
	// casovac T1 pro seriovy port (int) - 8bitovy s prednast.
	hwInit();
	ioInit();	// inic. hw a seriaku

	T0 = 0;		// ledka
	EX0 = 1;	// povol preruseni online tlacitkem

	EA = 1;

	RealyX = RealyY = 0;
	mngInit();

        while (1) {
		while (!online)		// cekej na online
			mngSleep(1);
		GetHpglCommand(command);
                if (strcmp(command,"PA") == 0)
			MoveMode = Absolut;
                if (strcmp(command,"PR") == 0)
			MoveMode = Relative;
                if (strcmp(command,"PU") == 0)
			mngPen(Up);
                if (strcmp(command,"PD") == 0)
			mngPen(Down);
		if (command[0] == 'P' && (command[1] == 'A' || command[1] == 'R' || command[1] == 'U' || command[1] == 'D')) {
                        while (GetHpglParameter(arg+0) && GetHpglParameter(arg+1))
				if (MoveMode == Absolut)
					mngAMove(arg[0], arg[1]);
				else
					mngRMove(arg[0], arg[1]);
                }
		if (strcmp(command,"IN") == 0) {
			mngPen(Up);
			mngRMove(-PAPERWIDTH-200,0);
			mngRMove(74,0);
			MoveMode = Absolut;
			PenX = 0;
			PenY = PAPERYINIT;	
			RealyX = RealyY = 0;
		}
		if (strcmp(command,"BP") == 0) {
			mngPen(Up);
			mngAMove(-RealyX, PAPERYINIT - RealyY);
		}
		if (strcmp(command,"ER") == 0 && GetHpglParameter(arg+0) && GetHpglParameter(arg+1)) {
			OldPenState = PenState;
			mngPen(Down);
			mngRMove(arg[0], 0);
			mngRMove(0, arg[1]);
			mngRMove(-arg[0], 0);
			mngRMove(0, -arg[1]);
			mngPen(OldPenState);
		}
		if (strcmp(command,"CI") == 0 && GetHpglParameter(arg+0))
			mngCircle(arg[0]);
		if (strcmp(command,"SO") == 0) {
                        if (GetHpglParameter(arg+0) && GetHpglParameter(arg+1)) {
				RealyX = arg[0];
				PenX -= arg[0];
				RealyY = arg[1];
				PenY -= arg[1];
			} else {
				RealyX += PenX;
				RealyY += PenY;
				PenX = PenY = 0;
			}
		}
		// povel pro rychlost
		if (strcmp(command,"SD") == 0 && GetHpglParameter(arg+0)) {
			rychlost = arg[0];
		}
	}
}
