/////////////////////////////////////////
// hardwarova aplikace ovladani plotru //
/////////////////////////////////////////

#define PORT	P1

typedef unsigned int word;
typedef unsigned char byte;

#include <8051.h>
#include "mnghw.h"

word rychlost;

void hwInit(void)	// inicializace portu a jinych zalezitosti
{
	PORT = 0xFF;

	// pocet kroku pro rozjezd a zaroven maximalni rychlost posunu
	// napr. pro 30 je to 3ms tj. max 4.1cm/s (rozjezd a dobrzdeni je polovicni)
	// Aritma uvadela 4cm rozjezd, 8cm plna rychlost (ROZJEZD=16), ale motory nebo pera to nemusi stihat
	rychlost = 20;
}

void hwSet(byte motor_x, byte motor_y, byte pero)
{
	PORT = (motor_x & 0x07) | ((motor_y << 3) & 0x38) | ((pero << 7) & 0x80);
	TL0 = 0;
	TH0 = 0;
}

// jeden tik T0 je 0.651us
void hwWait(word doba)			// ceka dany pocet 0.1ms
{
	doba = doba * 154 / 256;
	while ( TH0 < doba );
}
